import torch

states = 10
actions = 5
rewards = 7

system = torch.rand(states, rewards, states, actions)
system /= system.sum((0, 1))

policy = torch.rand(actions, states)
policy /= policy.sum(0)

epochs = 1000
value = 0.
for epoch in range(epochs):
    state = 1
    gain = 0.
    while state != 0:
        action = torch.multinomial(policy[:, state], 1).item()
        index = torch.multinomial(system[:, :, state, action].flatten(), 1).item()
        state, reward = index // rewards, -(index % rewards)
        gain += reward
    value += gain
value /= epochs
print(value)
